-- MySQL Script generated by MySQL Workbench
-- 05/06/16 14:26:19
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `mydb` DEFAULT CHARACTER SET utf8 ;
USE `mydb` ;

-- -----------------------------------------------------
-- Table `mydb`.`tblLocation`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblLocation` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblLocation` (
  `PKLocation` INT NOT NULL AUTO_INCREMENT,
  `Name` VARCHAR(45) NULL,
  PRIMARY KEY (`PKLocation`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblStaffRank`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblStaffRank` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblStaffRank` (
  `PKStaffRank` INT NOT NULL AUTO_INCREMENT,
  `StaffRank` VARCHAR(45) NULL,
  PRIMARY KEY (`PKStaffRank`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblStaff`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblStaff` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblStaff` (
  `PKStaff` INT NOT NULL AUTO_INCREMENT,
  `FirstName` VARCHAR(45) NULL,
  `LastNAme` VARCHAR(45) NULL,
  PRIMARY KEY (`PKStaff`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblStaffType`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblStaffType` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblStaffType` (
  `PKStaffType` INT NOT NULL AUTO_INCREMENT,
  `FKStaffRank` INT NOT NULL,
  `FKStaff` INT NOT NULL,
  PRIMARY KEY (`PKStaffType`),
  INDEX `fk_tblStaffType_tblStaffRank1_idx` (`FKStaffRank` ASC),
  INDEX `fk_tblStaffType_tblStaff1_idx` (`FKStaff` ASC),
  CONSTRAINT `fk_tblStaffType_tblStaffRank1`
    FOREIGN KEY (`FKStaffRank`)
    REFERENCES `mydb`.`tblStaffRank` (`PKStaffRank`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tblStaffType_tblStaff1`
    FOREIGN KEY (`FKStaff`)
    REFERENCES `mydb`.`tblStaff` (`PKStaff`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblShiftAvailable`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblShiftAvailable` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblShiftAvailable` (
  `PKShiftAvailable` INT NOT NULL AUTO_INCREMENT,
  `StartTime` DATETIME NULL,
  `EndTime` DATETIME NULL,
  `FKLocation` INT NOT NULL,
  `FKStaffRank` INT NOT NULL,
  PRIMARY KEY (`PKShiftAvailable`),
  INDEX `fk_tblShiftAvailable_tblLocation_idx` (`FKLocation` ASC),
  INDEX `fk_tblShiftAvailable_tblStaffRank1_idx` (`FKStaffRank` ASC),
  CONSTRAINT `fk_tblShiftAvailable_tblLocation`
    FOREIGN KEY (`FKLocation`)
    REFERENCES `mydb`.`tblLocation` (`PKLocation`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tblShiftAvailable_tblStaffRank1`
    FOREIGN KEY (`FKStaffRank`)
    REFERENCES `mydb`.`tblStaffRank` (`PKStaffRank`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblShiftStatus`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblShiftStatus` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblShiftStatus` (
  `PKShiftStatus` INT NOT NULL AUTO_INCREMENT,
  `ShiftStatusText` VARCHAR(45) NULL,
  PRIMARY KEY (`PKShiftStatus`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblShiftAllocation`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblShiftAllocation` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblShiftAllocation` (
  `PKShiftAllocation` INT NOT NULL AUTO_INCREMENT,
  `FKShiftAvailable` INT NOT NULL,
  `FKStaff_Next` INT NOT NULL,
  `FKShiftStatus` INT NOT NULL,
  `FKStaff` INT NOT NULL,
  PRIMARY KEY (`PKShiftAllocation`),
  INDEX `fk_tblShiftAllocation_tblShiftAvailable1_idx` (`FKShiftAvailable` ASC),
  INDEX `fk_tblShiftAllocation_tblStaff2_idx` (`FKStaff_Next` ASC),
  INDEX `fk_tblShiftAllocation_tblShiftStatus1_idx` (`FKShiftStatus` ASC),
  INDEX `fk_tblShiftAllocation_tblStaffType1_idx` (`FKStaff` ASC),
  CONSTRAINT `fk_tblShiftAllocation_tblShiftAvailable1`
    FOREIGN KEY (`FKShiftAvailable`)
    REFERENCES `mydb`.`tblShiftAvailable` (`PKShiftAvailable`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tblShiftAllocation_tblStaff2`
    FOREIGN KEY (`FKStaff_Next`)
    REFERENCES `mydb`.`tblStaff` (`PKStaff`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tblShiftAllocation_tblShiftStatus1`
    FOREIGN KEY (`FKShiftStatus`)
    REFERENCES `mydb`.`tblShiftStatus` (`PKShiftStatus`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tblShiftAllocation_tblStaffType1`
    FOREIGN KEY (`FKStaff`)
    REFERENCES `mydb`.`tblStaffType` (`PKStaffType`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblShiftStart`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblShiftStart` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblShiftStart` (
  `PKShiftStart` INT NOT NULL AUTO_INCREMENT,
  `ActualDateTime` DATETIME NULL,
  `ShiftStartTime` DATETIME NULL,
  `FKShiftAllocation` INT NOT NULL,
  `FKStaff_Requested_By` INT NOT NULL,
  PRIMARY KEY (`PKShiftStart`),
  INDEX `fk_tblShiftStart_tblShiftAllocation1_idx` (`FKShiftAllocation` ASC),
  INDEX `fk_tblShiftStart_tblStaff1_idx` (`FKStaff_Requested_By` ASC),
  CONSTRAINT `fk_tblShiftStart_tblShiftAllocation1`
    FOREIGN KEY (`FKShiftAllocation`)
    REFERENCES `mydb`.`tblShiftAllocation` (`PKShiftAllocation`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tblShiftStart_tblStaff1`
    FOREIGN KEY (`FKStaff_Requested_By`)
    REFERENCES `mydb`.`tblStaff` (`PKStaff`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblShiftEnd`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblShiftEnd` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblShiftEnd` (
  `PKShiftEnd` INT NOT NULL AUTO_INCREMENT,
  `ActualDateTime` DATETIME NULL,
  `ShiftEndTime` DATETIME NULL,
  `FKShiftAllocation` INT NOT NULL,
  PRIMARY KEY (`PKShiftEnd`),
  INDEX `fk_tblShiftEnd_tblShiftAllocation1_idx` (`FKShiftAllocation` ASC),
  CONSTRAINT `fk_tblShiftEnd_tblShiftAllocation1`
    FOREIGN KEY (`FKShiftAllocation`)
    REFERENCES `mydb`.`tblShiftAllocation` (`PKShiftAllocation`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`tblLogin`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `mydb`.`tblLogin` ;

CREATE TABLE IF NOT EXISTS `mydb`.`tblLogin` (
  `PKLogin` INT NOT NULL AUTO_INCREMENT,
  `Email` VARCHAR(45) NULL,
  `Password` VARCHAR(45) NULL,
  `Salt` VARCHAR(45) NULL,
  `FKStaff` INT NOT NULL,
  PRIMARY KEY (`PKLogin`),
  INDEX `fk_tblLogin_tblStaff1_idx` (`FKStaff` ASC),
  CONSTRAINT `fk_tblLogin_tblStaff1`
    FOREIGN KEY (`FKStaff`)
    REFERENCES `mydb`.`tblStaff` (`PKStaff`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
